# $Revision: 1.71 $, $Date: 2007-11-28 21:25:06 $
#
# Conditional build:
%bcond_without	initrd		# don't build initrd version
%bcond_without	diet		# link initrd version with static glibc instead of dietlibc
#
Summary:	Tool for creating and maintaining software RAID devices
Summary(pl.UTF-8):	Narzędzie do tworzenia i obsługi programowych macierzy RAID
Name:		mdadm
Version:	2.6.4
Release:	1
License:	GPL
Group:		Base
Source0:	http://www.kernel.org/pub/linux/utils/raid/mdadm/%{name}-%{version}.tar.bz2
# Source0-md5:	b616697aecc870d5d580bd6e010472a3
Source1:	%{name}.init
Source2:	%{name}.sysconfig
Patch0:		%{name}-degraded.patch
URL:		http://www.kernel.org/pub/linux/utils/raid/mdadm/
BuildRequires:	groff
BuildRequires:	rpmbuild(macros) >= 1.213
%if %{with initrd}
%{!?with_diet:BuildRequires:	glibc-static}
%if %{with diet}
BuildRequires:	dietlibc-static
%endif
Requires:	%{name}-initrd = %{epoch}:%{version}-%{release}
%endif
BuildRequires:	rpmbuild(macros) >= 1.268
Requires(post,preun):	/sbin/chkconfig
Requires:	/sbin/chkconfig
Requires:	rc-scripts >= 0.4.0.20
Obsoletes:	mdctl
BuildRoot:	%{tmpdir}/%{name}-%{version}-root-%(id -u -n)

%define		_sbindir		/sbin

%description
This package includes tool you need to set up and maintain a software
RAID device under Linux. It's thought as an alternative to raidtools
package.

%description -l pl.UTF-8
Pakiet ten zawiera narzędzie potrzebne do tworzenia i obsługi
programowych macierzy RAID. Program ten jest pomyślany jako
alternatywa dla pakietu raidtools.

%package initrd
Summary:	Tool for maintaining software RAID devices - initrd version
Summary(pl.UTF-8):	Narzędzie do obsługi programowych macierzy RAID, wersja dla initrd
Group:		Base

%description initrd
Tool for maintaining software RAID devices - statically linked for
initrd.

%description initrd -l pl.UTF-8
Narzędzie do zarządzania programowymi macierzami RAID - statycznie
skonsolidowane na potrzeby initrd.

%prep
%setup -q
#%patch0 -p1

%build
%if %{with initrd}
%if %{with diet}
%{__make} mdadm \
	CC="diet %{__cc} %{rpmcflags} %{rpmldflags} -static" \
	CWFLAGS="-Wall"
mv -f mdadm initrd-mdadm
%{__make} clean
diet %{__cc}  -DUCLIBC -DMDASSEMBLE %{rpmcflags} %{rpmldflags} \
	-DHAVE_STDINT_H -o sha1.o -c sha1.c
diet %{__cc} -DUCLIBC -DMDASSEMBLE %{rpmcflags} %{rpmldflags} -static \
	-o initrd-mdassemble mdassemble.c Assemble.c Manage.c config.c dlink.c \
	util.c super0.c super1.c sha1.o
%else
%{__make} mdadm.static \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} -D_GNU_SOURCE" \
	LDFLAGS="%{rpmldflags}"
mv -f mdadm.static initrd-mdadm
%{__make} clean
%{__cc} -DMDASSEMBLE %{rpmcflags} %{rpmldflags} -DHAVE_STDINT_H \
	-o sha1.o -c sha1.c
%{__cc} -DMDASSEMBLE %{rpmcflags} %{rpmldflags} -DHAVE_STDINT_H -static \
	-o initrd-mdassemble mdassemble.c Assemble.c Manage.c config.c dlink.c \
	util.c super0.c super1.c sha1.o
%endif
%{__make} clean
%endif

%{__make} \
	CC="%{__cc}" \
	CFLAGS="%{rpmcflags} -D_GNU_SOURCE" \
	LDFLAGS="%{rpmldflags}" \
	SYSCONFDIR="%{_sysconfdir}"

%install
rm -rf $RPM_BUILD_ROOT
install -d $RPM_BUILD_ROOT{%{_sbindir},%{_mandir}/man{5,8},/etc/{rc.d/init.d,sysconfig}}

%if %{with initrd}
install initrd-mdadm $RPM_BUILD_ROOT%{_sbindir}
install initrd-mdassemble $RPM_BUILD_ROOT%{_sbindir}
ln -s initrd-mdadm $RPM_BUILD_ROOT%{_sbindir}/initrd-mdctl
%endif

install mdadm $RPM_BUILD_ROOT%{_sbindir}

install *.5 $RPM_BUILD_ROOT%{_mandir}/man5
install *.8 $RPM_BUILD_ROOT%{_mandir}/man8

install mdadm.conf-example $RPM_BUILD_ROOT%{_sysconfdir}/mdadm.conf

ln -s mdadm $RPM_BUILD_ROOT%{_sbindir}/mdctl

install %{SOURCE1} $RPM_BUILD_ROOT/etc/rc.d/init.d/%{name}
install %{SOURCE2} $RPM_BUILD_ROOT/etc/sysconfig/%{name}

%clean
rm -rf $RPM_BUILD_ROOT

%post
/sbin/chkconfig --add %{name}
%service mdadm restart "RAID monitoring"

%preun
if [ "$1" = "0" ]; then
	%service mdadm stop
	/sbin/chkconfig --del mdadm
fi

%files
%defattr(644,root,root,755)
%doc ANNOUNCE* ChangeLog TODO
%attr(755,root,root) %{_sbindir}/*
%attr(640,root,root) %config(noreplace,missingok) %verify(not md5 mtime size) %{_sysconfdir}/mdadm.conf
%{_mandir}/man?/*
%attr(754,root,root) /etc/rc.d/init.d/%{name}
%attr(640,root,root) %config(noreplace) %verify(not md5 mtime size) /etc/sysconfig/%{name}
%if %{with initrd}
%exclude %{_sbindir}/initrd-*

%files initrd
%defattr(644,root,root,755)
%attr(755,root,root) %{_sbindir}/initrd-*
%endif

%define date	%(echo `LC_ALL="C" date +"%a %b %d %Y"`)
%changelog
* %{date} PLD Team <feedback@pld-linux.org>
All persons listed below can be reached at <cvs_login>@pld-linux.org

$Log: mdadm.spec,v $
Revision 1.71  2007-11-28 21:25:06  glen
- use %service

Revision 1.70  2007-10-19 16:49:48  areq
- 2.6.4

Revision 1.69  2007/08/24 20:43:00  adamg
- updated to 2.6.3

Revision 1.68  2007/05/24 01:08:07  aredridel
- 2.6.2
- s/deit/diet/

Revision 1.67  2007/05/09 13:46:20  arekm
- Switch to dietlibc; mdassemble works with it on x86_64.

Revision 1.66  2007/04/09 20:49:10  arekm
- always define UCLIBC/HAVE_STDINT_H

Revision 1.65  2007/02/22 21:40:00  arekm
- up to 2.6.1

Revision 1.64  2007/02/13 06:46:53  glen
- tabs in preamble

Revision 1.63  2007/02/12 00:49:07  baggins
- converted to UTF-8

Revision 1.62  2007/01/08 09:16:52  rotom
- up to 2.6

Revision 1.61  2006/11/11 14:56:48  arekm
- fix initrd build

Revision 1.60  2006/11/11 14:51:07  arekm
- up to 2.5.6

Revision 1.59  2006/08/07 16:59:07  paszczus
- updated to 2.5.3

Revision 1.58  2006/07/17 18:05:38  sparky
- minimal uClibc-static version on ppc

Revision 1.57  2006/07/11 16:57:27  qboosh
- added fix patch (fixes build with uClibc without ftw())

Revision 1.56  2006/07/06 22:19:32  sparky
- 2.5.2

Revision 1.55  2006/06/20 12:44:48  sparky
- initrd works, works with uClibc but requires new one

Revision 1.54  2006/06/17 11:56:22  sparky
- fixed initrd-mdassemble build (tested only uclibc@ppc)

Revision 1.53  2006/06/17 09:44:14  paszczus
- updated to 2.5.1 (many changes)
- rel 0.1 cause builds only without initrd (added TODO)

Revision 1.52  2006/03/30 07:35:54  paszczus
- updated to 2.4

Revision 1.51  2006/03/27 08:33:10  qboosh
- straight R is just workaround, don't remove specific R() for chkconfig

Revision 1.50  2006/03/26 17:30:51  blues
- simply require..

Revision 1.49  2006/02/08 15:18:28  paszczus
- removed Patch1
- corrected previous commit log
- release 1 ; STBR

Revision 1.48  2006/02/08 15:09:35  paszczus
- updated to 2.3.1
- updated mdadm-degraded.patch
- release 0.1 (please check Patch1)

Revision 1.47  2006/01/14 02:00:43  sparky
- uClibc-static from AC is broken on ppc, disable it
- rel 3, STBR Ac

Revision 1.46  2006/01/05 19:38:41  arekm
- rel 2; fix segfaults

Revision 1.45  2005/12/14 22:36:52  dzeus
- up to 2.2

Revision 1.44  2005/10/01 22:21:51  sparky
- updated to 2.1: raid10 and superblock v1 fixes

Revision 1.43  2005/09/05 22:15:07  qboosh
- fixed mdassemble build

Revision 1.42  2005/09/03 22:27:26  arekm
- up to 2.0

Revision 1.41  2005/08/26 13:01:42  paszczus
- md5

Revision 1.40  2005/08/26 12:49:14  paszczus
- use tar.bz2 compression

Revision 1.39  2005/08/26 12:47:29  paszczus
- changed to mirror site, but there are more files than on main site

Revision 1.38  2005/06/28 08:24:13  blues
- don't require mdadm on _every_ system. Require strict version of
  mdadm-initrd in mdadm. Should be enought

Revision 1.37  2005/06/16 10:00:53  hawk
- release 2 (1 is for Ra)

Revision 1.36  2005/06/14 19:53:59  areq
- 1.12.0

Revision 1.35  2005/05/29 06:20:21  paszczus
- added poor URL (from freshmeat.net link)

Revision 1.34  2005/05/11 15:27:01  qboosh
- use x8664 macro

Revision 1.33  2005/04/11 07:33:34  paszczus
- updated to 1.11.0 (in 1.10.0 -a options always fail)
- release 2 (rel 1 is for Ra)
- STBR

Revision 1.32  2005/04/05 15:29:35  darekr
- added ChangeLog to %doc

Revision 1.31  2005/04/05 15:07:17  hawk
- release 2 (1 is for Ra)

Revision 1.30  2005/04/05 15:02:36  paszczus
- updated to 1.10.0

Revision 1.29  2005/02/04 20:43:41  hawk
- release 2 (1 for RA)

Revision 1.28  2005/02/04 19:54:04  areq
- 1.9.0

Revision 1.27  2005/02/02 20:08:33  hawk
- release 2 (1 will be for RA)

Revision 1.26  2004/11/01 22:53:51  areq
- 1.8.0

Revision 1.25  2004/08/17 13:59:44  arekm
- updated to 1.7.0

Revision 1.24  2004/07/13 10:06:56  qboosh
- added degraded patch (needed to boot from array with disk missing)
- release 2

Revision 1.23  2004/06/13 21:06:13  arekm
- updated to 1.6.0

Revision 1.22  2004/05/23 19:22:35  qboosh
- added _without_uClibc bcond, use it by default on amd64; release 2

Revision 1.21  2004/01/22 10:24:16  qboosh
- bcond fix, cosmetics

Revision 1.20  2004/01/22 10:18:53  arekm
- updated to 1.5.0; new bconds; new command mdassemble (we will use it in geninitrd); support for RAID6

Revision 1.19  2004/01/21 15:01:24  arekm
- fix building with gkh; rel 3

Revision 1.18  2004/01/17 20:00:47  arekm
- use uClibc for static mdadm (this works)

Revision 1.17  2003/10/31 12:30:58  orzech
- up to 1.4.0

Revision 1.16  2003/10/25 13:25:41  ankry
- pl: linkowanie -> konsolidacja, shell -> powłoka

Revision 1.15  2003/09/06 20:16:09  blues
- release 2

Revision 1.14  2003/08/22 15:44:04  ankry
- cosmetics: spaces -> tabs

Revision 1.13  2003/08/12 22:32:50  ankry
- cosmetics

Revision 1.12  2003/08/04 07:47:45  arekm
- update to 1.3.0 and enable initrd version by default

Revision 1.11  2003/05/28 12:59:42  malekith
- massive attack: source-md5

Revision 1.10  2003/05/25 05:50:30  misi3k
- massive attack s/pld.org.pl/pld-linux.org/

Revision 1.9  2003/05/22 22:12:48  malekith
- BOOT patch is back; release 2

Revision 1.8  2003/03/14 02:25:54  misiek
- updated to 1.2.0

Revision 1.7  2003/03/03 08:28:27  misiek
- almost updated to 1.1.0 (BOOT patch needs fixes)

Revision 1.6  2002/12/07 14:33:27  ankry
- fix improper usage of %%{_sysconfdir}

Revision 1.5  2002/09/07 19:45:48  misiek
- detect 0 devices, too
- run monitoring daemon
- rel 2

Revision 1.4  2002/08/12 13:27:08  malekith
- --without initrd -> --with initrd (bsp now handles starting raid OK)
- new %doc
- BOOT patch enabled (why was it disabled)

Revision 1.3  2002/08/12 13:01:45  misiek
- updated to 1.0.1

Revision 1.2  2002/05/10 18:10:16  qboosh
- typos and other cosmetics

Revision 1.1  2002/05/10 06:54:43  misiek
- new version of mdctl tool (now named mdadm); update of BOOT patch required

Revision 1.11  2002/03/16 12:26:22  malekith
- initrd subpackage added
- rel 4

Revision 1.10  2002/03/05 16:18:34  marcus
- rel.3.

Revision 1.9  2002/03/05 16:18:07  marcus
- removed uclibc stuff

Revision 1.8  2002/02/22 23:29:15  kloczek
- removed all Group fields translations (oure rpm now can handle translating
  Group field using gettext).

Revision 1.7  2002/01/22 22:32:42  qboosh
- typo

Revision 1.6  2002/01/22 08:42:43  qboosh
- s/pld-list/feedback/, typos

Revision 1.5  2002/01/21 17:49:59  malekith
- rel 2
- BOOT -> embed

Revision 1.3  2001/08/07 16:29:24  kloczek
- typo.

Revision 1.2  2001/08/07 16:03:31  kloczek
- spec adaptterized, added more macros and few other minor changes.

Revision 1.1  2001/08/07 10:45:20  malekith
- from scratch
